﻿// helloworldDlg.cpp : implementation file
//

#include "stdafx.h"
#include "helloworld.h"
#include "helloworldDlg.h"
#include "chartdir.h"
#include <vector>
#include <algorithm>
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

/////////////////////////////////////////////////////////////////////////////
// CHelloworldDlg dialog

CHelloworldDlg::CHelloworldDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHelloworldDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

//
// Destructor
//
CHelloworldDlg::~CHelloworldDlg()
{
	delete m_ChartViewer.getChart();
}

void CHelloworldDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHelloworldDlg)
	DDX_Control(pDX, IDC_CHART, m_ChartViewer);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHelloworldDlg, CDialog)
	//{{AFX_MSG_MAP(CHelloworldDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CHelloworldDlg::OnBnClickedButton1)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHelloworldDlg message handlers

void CHelloworldDlg::drawChart()
{
	CChartViewer *viewer = &m_ChartViewer;

	SYSTEMTIME st;
	GetLocalTime(&st);
	double now = Chart::chartTime(st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute,
		st.wSecond) + st.wMilliseconds / 1000.0;
	RanSeries r(st.wHour * 3600 * 20 + st.wMinute * 60 * 20 + st.wSecond * 20 + st.wMilliseconds / 50);
	
	// The data for the bar chart
	//double data[] = { 85, 156, 179.5, 211, 123 };

	// The labels for the bar chart
	const char *labels[] = { "Mon", "Tue", "Wed", "Thu", "Fri" };

	// Create a XYChart object of size 250 x 250 pixels
	XYChart *c = new XYChart(250, 250, 0xcfffffff);

	// Set the plotarea at (30, 20) and of size 200 x 200 pixels
	c->setPlotArea(30, 20, 200, 200);

	// Add a bar chart layer using the given data
	c->addBarLayer(r.getSeries(5, 100, 300));

	// Set the labels on the x axis.
	c->xAxis()->setLabels(StringArray(labels, (int)(sizeof(labels) / sizeof(labels[0]))));

	// Output the chart
	delete viewer->getChart();
	viewer->setChart(c);
}

BOOL CHelloworldDlg::OnInitDialog()
{
	SetWindowLongPtr(m_hWnd, GWL_EXSTYLE, GetWindowLongPtr(m_hWnd, GWL_EXSTYLE) | WS_EX_COMPOSITED);
	
	CDialog::OnInitDialog();

	// *** code automatically generated by VC++ MFC AppWizard ***
	// Set the icon for this dialog.  The framework does this automatically
	// when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	drawChart();
	SetTimer(1, 100, 0);

	return TRUE;
}

//
// Handles timer events
//
void CHelloworldDlg::OnTimer(UINT_PTR nIDEvent)
{
	drawChart();
	CDialog::OnTimer(nIDEvent);
}

// *** code automatically generated by VC++ MFC AppWizard ***
// If you add a minimize button to your dialog, you will need the code below
// to draw the icon.  For MFC applications using the document/view model,
// this is automatically done for you by the framework.
void CHelloworldDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// *** code automatically generated by VC++ MFC AppWizard ***
// The system calls this to obtain the cursor to display while the user drags
// the minimized window.
HCURSOR CHelloworldDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CHelloworldDlg::OnBnClickedButton1()
{
	CRect rect;
	m_ChartViewer.GetWindowRect(&rect);
	ScreenToClient(&rect);

	rect.left += 1;
	m_ChartViewer.MoveWindow(&rect);
	drawChart();
}

